
// Learn about this code:
// http://callbackhell.com/

var fs = require('fs');
var gm = require('gm');

var source = __dirname + "/images/";
var dest = __dirname + "/images-resize/";
var widths = [100, 200];

fs.readdir(source, function (err, files) {
  if (err) {
    console.log('Error finding files: ' + err)
  }
  else {
    files.forEach(function (filename, fileIndex) {
      console.log(filename)
      gm(source + filename).size(function (err, values) {
        if (err) {
          console.log('Error identifying file size: ' + err)
        }
        else {
          console.log(filename + ' : ' + values)
          aspect = (values.width / values.height)
          widths.forEach(function (width, widthIndex) {
            var height = Math.round(width / aspect)
            console.log('resizing ' + filename + 'to ' + height + 'x' + height)
            this.resize(width, height).write(dest + 'w' + width + '_' + filename, function(err) {
              if (err) console.log('Error writing file: ' + err)
            })
          }.bind(this))
        }
      })
    })
  }
})
